/*!
* Backbone.CollectionView, v0.7.1
* Copyright (c)2013 Rotunda Software, LLC.
* Distributed under MIT license
* http://github.com/rotundasoftware/backbone-collection-view
*/

(function(){var e=Backbone.View,t="model",i=["collection","modelView","modelViewOptions","itemTemplate","emptyListCaption","selectable","clickToSelect","selectableModelsFilter","visibleModelsFilter","selectMultiple","clickToToggle","processKeyEvents","sortable","sortableModelsFilter","itemTemplateFunction","detachedRendering"],s=["collection","modelView","modelViewOptions","itemTemplate","selectableModelsFilter","sortableModelsFilter","visibleModelsFilter","itemTemplateFunction","detachedRendering"],l={background:"transparent",border:"none","box-shadow":"none"};Backbone.CollectionView=Backbone.View.extend({tagName:"ul",events:{"mousedown li, td":"_listItem_onMousedown","dblclick li, td":"_listItem_onDoubleClick",click:"_listBackground_onClick","click ul.collection-list, table.collection-list":"_listBackground_onClick",keydown:"_onKeydown"},spawnMessages:{focus:"focus"},passMessages:{"*":"."},initialize:function(e){var t=this;e=_.extend({},{collection:null,modelView:this.modelView||null,modelViewOptions:{},itemTemplate:null,itemTemplateFunction:null,selectable:!0,clickToSelect:!0,selectableModelsFilter:null,visibleModelsFilter:null,sortableModelsFilter:null,selectMultiple:!1,clickToToggle:!1,processKeyEvents:!0,sortable:!1,detachedRendering:!1,emptyListCaption:null},e),_.each(i,function(i){t[i]=e[i]}),this.collection||(this.collection=new Backbone.Collection),this._isBackboneCourierAvailable()&&Backbone.Courier.add(this),this.$el.data("view",this),this.$el.addClass("collection-list"),this.processKeyEvents&&this.$el.attr("tabindex",0),this.selectedItems=[],this._updateItemTemplate(),_.isUndefined(this.collection)||_.isNull(this.collection)||(this.listenTo(this.collection,"add",function(){this.render(),this._isBackboneCourierAvailable()&&this.spawn("add")}),this.listenTo(this.collection,"remove",function(){this.render(),this._isBackboneCourierAvailable()&&this.spawn("remove")}),this.listenTo(this.collection,"reset",function(){this.render(),this._isBackboneCourierAvailable()&&this.spawn("reset")})),this.viewManager=new ChildViewContainer},setOption:function(e,t){var l=this;if("collection"===e)this._setCollection(t);else{if(!_.contains(i,e))throw e+" is not an allowed option";switch(e){case"selectMultiple":this[e]=t,!t&&this.selectedItems.length>1&&this.setSelectedModel(_.first(this.selectedItems),{by:"cid"});break;case"selectable":!t&&this.selectedItems.length>0&&this.setSelectedModels([]),this[e]=t;break;case"selectableModelsFilter":this[e]=t,t&&_.isFunction(t)&&this._validateSelection();break;case"itemTemplate":this[e]=t,this._updateItemTemplate();break;case"processKeyEvents":this[e]=t,t&&this.$el.attr("tabindex",0);break;case"modelView":this[e]=t,this.viewManager.each(function(e){l.viewManager.remove(e),e.remove()});break;default:this[e]=t}_.contains(s,e)&&this.render()}},getSelectedModel:function(e){return _.first(this.getSelectedModels(e))},getSelectedModels:function(e){var i=this;e=_.extend({},{by:t},e);var s=e.by,l=[];switch(s){case"id":_.each(this.selectedItems,function(e){l.push(i.collection.get(e).id)});break;case"cid":l=l.concat(this.selectedItems);break;case"offset":var n,o=0;this._isRenderedAsTable()?n=this.$el.find("> tbody > [data-item-id]:visible"):this._isRenderedAsList()&&(n=this.$el.find("> [data-item-id]:visible")),n.each(function(){var e=$(this);e.is(".selected")&&l.push(o),o++});break;case"model":_.each(this.selectedItems,function(e){l.push(i.collection.get(e))});break;case"view":_.each(this.selectedItems,function(e){l.push(i.viewManager.findByModel(i.collection.get(e)))});break;default:throw"The referenceBy property was not properly set"}return l},setSelectedModels:function(e,i){if(!this.selectable)throw"Attempt to set selected items on non-selectable list";if(!_.isArray(e))throw"Invalid parameter value";i=_.extend({},{silent:!1,by:t},i);var s=i.by,l=[];switch(s){case"cid":l=e;break;case"id":this.collection.each(function(t){_.contains(e,t.id)&&l.push(t.cid)});break;case"model":l=_.pluck(e,"cid");break;case"view":_.each(e,function(e){l.push(e.model.cid)});break;case"offset":var n,o=0;this._isRenderedAsTable()?n=this.$el.find("> tbody > [data-item-id]:visible"):this._isRenderedAsList()&&(n=this.$el.find("> [data-item-id]:visible")),n.each(function(){var t=$(this);_.contains(e,o)&&l.push(t.attr("data-item-id")),o++});break;default:throw"The referenceBy property was not properly set"}var d=this.getSelectedModels(),c=_.clone(this.selectedItems);this.selectedItems=this._convertStringsToInts(l),this._validateSelection();var a=this.getSelectedModels();this._containSameElements(c,this.selectedItems)||(this._addSelectedClassToSelectedItems(c),i.silent||(this.trigger("selectionChanged",a,d),this._isBackboneCourierAvailable()&&this.spawn("selectionChanged",{selectedModels:a,oldSelectedModels:d})),this.updateDependentControls())},setSelectedModel:function(e,t){_.isUndefined(e)||_.isNull(e)?this.setSelectedModels([],t):this.setSelectedModels([e],t)},render:function(){var e=this;this.selectable&&this._saveSelection();var t;if(this._isRenderedAsTable()){var i=this.$el.find("> tbody");i.length>0&&(t=i)}_.isUndefined(t)&&(t=this.$el);var s=this.viewManager;if(this.viewManager=new ChildViewContainer,s.each(function(t){e.collection.get(t.model.cid)?t.$el.detach():t.remove()}),t.empty(),this.detachedRendering)var n=document.createDocumentFragment();if(this.collection.each(function(i){var l;if(l=s.findByModelCid(i.cid),_.isUndefined(l)){var o=this._getModelViewOptions(i);l=this._createNewModelView(i,o),l.collectionListView=e}var d=this._wrapModelView(l);this.detachedRendering?n.appendChild(d[0]):t.append(d);var c=l.render();c===!1&&(d.hide(),d.addClass("not-visible")),_.isFunction(this.visibleModelsFilter)&&(this.visibleModelsFilter(i)||(1===d.children().length?d.hide():l.$el.hide(),d.addClass("not-visible"))),this.viewManager.add(l)},this),this.detachedRendering&&t.append(n),this.sortable){var o=_.extend({axis:"y",distance:10,forcePlaceholderSize:!0,start:_.bind(this._sortStart,this),change:_.bind(this._sortChange,this),stop:_.bind(this._sortStop,this),receive:_.bind(this._receive,this),over:_.bind(this._over,this)},_.result(this,"sortableOptions"));null===this.sortableModelsFilter?e._isRenderedAsTable()?o.items="> tbody > *":e._isRenderedAsList()&&(o.items="> *"):_.isString(this.sortableModelsFilter)?o.items=this.sortableModelsFilter:_.isFunction(this.sortableModelsFilter)&&(e._isRenderedAsTable()?o.items="> tbody > tr:not(.not-sortable)":e._isRenderedAsList()&&(o.items="> li:not(.not-sortable)")),this.$el=this.$el.sortable(o)}if(this.emptyListCaption){var d=this.viewManager.find(function(e){return!e.$el.hasClass("not-visible")});if(_.isUndefined(d)){var c;c=_.isFunction(this.emptyListCaption)?this.emptyListCaption():this.emptyListCaption;var a=$("<var class='empty-list-caption'>"+c+"</var>");$emptyListCaptionEl=this._isRenderedAsList()?a.wrapAll("<li class='not-sortable'></li>").parent().css(l):a.wrapAll("<tr class='not-sortable'><td></td></tr>").parent().parent().css(l),this.$el.append($emptyListCaptionEl)}}this.trigger("render"),this._isBackboneCourierAvailable()&&this.spawn("render"),this.selectable&&(this._restoreSelection(),this.updateDependentControls()),_.isFunction(this.onAfterRender)&&this.onAfterRender()},updateDependentControls:function(){this.trigger("updateDependentControls",this.getSelectedModels()),this._isBackboneCourierAvailable()&&this.spawn("updateDependentControls",{selectedModels:this.getSelectedModels()})},remove:function(){this.viewManager.each(function(e){e.remove()}),Backbone.View.prototype.remove.apply(this,arguments)},_validateSelectionAndRender:function(){this._validateSelection(),this.render()},_getClickedItemId:function(e){var t=null,i=$(e.currentTarget);if(i.closest(".collection-list").get(0)===this.$el.get(0)){var s=i.closest("[data-item-id]");return s.length>0&&(t=s.attr("data-item-id"),$.isNumeric(t)&&(t=parseInt(t,10))),t}},_setCollection:function(e){e!==this.collection&&(this.collection=e,this.collection.bind("add",this.render,this),this.collection.bind("remove",this._validateSelectionAndRender,this),this.collection.bind("reset",this._validateSelectionAndRender,this)),this.render()},_updateItemTemplate:function(){var e;if(this.itemTemplate){if(0===$(this.itemTemplate).length)throw"Could not find item template from selector: "+this.itemTemplate;e=$(this.itemTemplate).html()}else e=this.$(".item-template").html();e&&(this.itemTemplateFunction=_.template(e))},_validateSelection:function(){var e=_.pluck(this.collection.models,"cid");this.selectedItems=_.intersection(e,this.selectedItems),_.isFunction(this.selectableModelsFilter)&&(this.selectedItems=_.filter(this.selectedItems,function(e){return this.selectableModelsFilter.call(this,this.collection.get(e))},this))},_saveSelection:function(){if(!this.selectable)throw"Attempt to save selection on non-selectable list";this.savedSelection={items:this.selectedItems,offset:this.getSelectedModel({by:"offset"})}},_restoreSelection:function(){if(!this.savedSelection)throw"Attempt to restore selection but no selection has been saved!";this.setSelectedModels([],{silent:!0}),this.savedSelection.items.length>0&&(this.setSelectedModels(this.savedSelection.items,{by:"cid",silent:!0}),0===this.selectedItems.length&&this.setSelectedModel(this.savedSelection.offset,{by:"offset"}),this.selectedItems.length!==this.savedSelection.items.length&&(this.trigger("selectionChanged",this.getSelectedModels(),[]),this._isBackboneCourierAvailable()&&this.spawn("selectionChanged",{selectedModels:this.getSelectedModels(),oldSelectedModels:[]}))),delete this.savedSelection},_addSelectedClassToSelectedItems:function(e){_.isUndefined(e)&&(e=[]);var t=e;t=_.without(t,this.selectedItems),_.each(t,function(e){this.$el.find("[data-item-id="+e+"]").removeClass("selected")},this);var i=this.selectedItems;i=_.without(i,e),_.each(i,function(e){this.$el.find("[data-item-id="+e+"]").addClass("selected")},this)},_reorderCollectionBasedOnHTML:function(){var e=this;this.$el.children().each(function(){var t=$(this).attr("data-item-id");if(t){var i=e.collection.get(t);i&&(e.collection.remove(i,{silent:!0}),e.collection.add(i,{silent:!0}))}}),this.collection.trigger("reorder"),this._isBackboneCourierAvailable()&&this.spawn("reorder")},_getModelViewConstructor:function(){return this.modelView||e},_getModelViewOptions:function(e){return _.extend({model:e},this.modelViewOptions)},_createNewModelView:function(e,t){var i=this._getModelViewConstructor(e);if(_.isUndefined(i))throw"Could not find modelView constructor for model";return new i(t)},_wrapModelView:function(e){var t,i=this;return this._isRenderedAsTable()?t=e.$el.attr("data-item-id",e.model.cid):this._isRenderedAsList()&&(t=e.$el.wrapAll("<li data-item-id='"+e.model.cid+"'></li>").parent()),_.isFunction(this.sortableModelsFilter)&&(this.sortableModelsFilter.call(i,e.model)||t.addClass("not-sortable")),_.isFunction(this.selectableModelsFilter)&&(this.selectableModelsFilter.call(i,e.model)||t.addClass("not-selectable")),t},_convertStringsToInts:function(e){return _.map(e,function(e){if(!_.isString(e))return e;var t=parseInt(e,10);return t==e?t:e})},_containSameElements:function(e,t){if(e.length!=t.length)return!1;var i=_.intersection(e,t).length;return i==e.length},_isRenderedAsTable:function(){return"table"===this.$el.prop("tagName").toLowerCase()},_isRenderedAsList:function(){return!this._isRenderedAsTable()},_charCodes:{upArrow:38,downArrow:40},_isBackboneCourierAvailable:function(){return!_.isUndefined(Backbone.Courier)},_sortStart:function(e,t){var i=this.collection.get(t.item.attr("data-item-id"));this.trigger("sortStart",i),this._isBackboneCourierAvailable()&&this.spawn("sortStart",{modelBeingSorted:i})},_sortChange:function(e,t){var i=this.collection.get(t.item.attr("data-item-id"));this.trigger("sortChange",i),this._isBackboneCourierAvailable()&&this.spawn("sortChange",{modelBeingSorted:i})},_sortStop:function(e,t){var i=this.collection.get(t.item.attr("data-item-id")),s=this.$el.children().index(t.item);-1==s&&this.collection.remove(i),this._reorderCollectionBasedOnHTML(),this.updateDependentControls(),this.trigger("sortStop",i,s),this._isBackboneCourierAvailable()&&this.spawn("sortStop",{modelBeingSorted:i,newIndex:s})},_receive:function(e,t){var i=t.sender,s=i.data("view");if(s&&s.collection){var l=this.$el.children().index(t.item),n=s.collection.get(t.item.attr("data-item-id"));this.collection.add(n,{at:l}),n.collection=this.collection,this.setSelectedModel(n)}},_over:function(){this.$el.find(".empty-list-caption").hide()},_onKeydown:function(e){if(!this.processKeyEvents)return!0;var t=!1;if(1==this.getSelectedModels({by:"offset"}).length){var i=this.getSelectedModel({by:"offset"});e.which===this._charCodes.upArrow&&0!==i?(this.setSelectedModel(i-1,{by:"offset"}),t=!0):e.which===this._charCodes.downArrow&&i!==this.collection.length-1&&(this.setSelectedModel(i+1,{by:"offset"}),t=!0)}return!t},_listItem_onMousedown:function(e){if(this.selectable&&this.clickToSelect){var t=this._getClickedItemId(e);if(t){if(_.isFunction(this.selectableModelsFilter)&&!this.selectableModelsFilter.call(this,this.collection.get(t)))return;if(this.selectMultiple&&e.shiftKey){var i=-1;this.selectedItems.length>0&&this.collection.find(function(e){return i++,_.contains(this.selectedItems,e.cid)},this);var s=-1;this.collection.find(function(e){return s++,e.cid==t},this);for(var l=-1==i?s:i,n=Math.min(s,l),o=Math.max(s,l),d=[],c=n;o>=c;c++)d.push(this.collection.at(c).cid);if(this.setSelectedModels(d,{by:"cid"}),document.selection&&document.selection.empty)document.selection.empty();else if(window.getSelection){var a=window.getSelection();a&&a.removeAllRanges&&a.removeAllRanges()}}else this.selectMultiple&&(this.clickToToggle||e.metaKey)?_.contains(this.selectedItems,t)?this.setSelectedModels(_.without(this.selectedItems,t),{by:"cid"}):this.setSelectedModels(_.union(this.selectedItems,t),{by:"cid"}):this.setSelectedModels([t],{by:"cid"})}else this.setSelectedModels([])}},_listItem_onDoubleClick:function(e){var t=this._getClickedItemId(e);if(t){var i=this.collection.get(t);this.trigger("doubleClick",i),this._isBackboneCourierAvailable()&&this.spawn("doubleClick",{clickedModel:i})}},_listBackground_onClick:function(e){this.selectable&&$(e.target).is(".collection-list")&&this.setSelectedModels([])}},{setDefaultModelViewConstructor:function(t){e=t}}),ChildViewContainer=function(e,t){var i=function(e){this._views={},this._indexByModel={},this._indexByCustom={},this._updateLength(),t.each(e,this.add,this)};t.extend(i.prototype,{add:function(e,t){var i=e.cid;this._views[i]=e,e.model&&(this._indexByModel[e.model.cid]=i),t&&(this._indexByCustom[t]=i),this._updateLength()},findByModel:function(e){return this.findByModelCid(e.cid)},findByModelCid:function(e){var t=this._indexByModel[e];return this.findByCid(t)},findByCustom:function(e){var t=this._indexByCustom[e];return this.findByCid(t)},findByIndex:function(e){return t.values(this._views)[e]},findByCid:function(e){return this._views[e]},remove:function(e){var i=e.cid;e.model&&delete this._indexByModel[e.model.cid],t.any(this._indexByCustom,function(e,t){return e===i?(delete this._indexByCustom[t],!0):void 0},this),delete this._views[i],this._updateLength()},call:function(e){this.apply(e,t.tail(arguments))},apply:function(e,i){t.each(this._views,function(s){t.isFunction(s[e])&&s[e].apply(s,i||[])})},_updateLength:function(){this.length=t.size(this._views)}});var s=["forEach","each","map","find","detect","filter","select","reject","every","all","some","any","include","contains","invoke","toArray","first","initial","rest","last","without","isEmpty","pluck"];return t.each(s,function(e){i.prototype[e]=function(){var i=t.values(this._views),s=[i].concat(t.toArray(arguments));return t[e].apply(t,s)}}),i}(Backbone,_)})();